package com.hisense.monitormanage.config;


import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;//
import org.springframework.context.annotation.Configuration;//
import springfox.documentation.builders.ApiInfoBuilder;//
import springfox.documentation.builders.PathSelectors;//
import springfox.documentation.builders.RequestHandlerSelectors;//
import springfox.documentation.service.ApiInfo;//
import springfox.documentation.service.Contact;//
import springfox.documentation.spi.DocumentationType;//
import springfox.documentation.spring.web.plugins.Docket;//
import springfox.documentation.swagger2.annotations.EnableSwagger2;//

/**
 * @author admin
 * @version 1.0.0
 * @ClassName SwaggerConfig.java
 * @Description swagger配置类
 * @createTime 2022年05月17日 09:39:00
 */
@Configuration
@EnableSwagger2
public class SwaggerConfig {

    @Value("${swagger.enable:false}")
    private boolean enable;

    @Bean
    public Docket createRestApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .enable(enable)
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.hisense.monitormanage.controller"))
                .paths(PathSelectors.any())
                .build()
                .apiInfo(apiInfo());
    }

    //构建 api文档的详细信息函数,注意这里的注解引用的是哪个
    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                //页面标题
                .title("Spring Boot  Swagger2 接口文档")
                //创建人
                .contact(new Contact("Hisense", "", "332163564@qq.com"))
                //版本号
                .version("1.0")
                //描述
                .description("API 描述")
                .build();
    }
}
