package com.hisense.monitormanage.controller;

import com.hisense.monitormanage.entity.Result;
import com.hisense.monitormanage.service.MonitorService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;

@RestController
@RequestMapping("api/project")
@Api(tags = "视频流")
public class FileController {

    @Autowired
    private MonitorService monitorService;

    /**
     * 根据摄像头标识获取视频流
     *
     * @param channelCode
     * @return
     * @throws IOException
     */
    @GetMapping("file")
    @ApiOperation("根据摄像头标识获取视频流")
    @ApiImplicitParam(name = "channelCode", value = "摄像头标识", required = true, dataType = "String")
    public Result File(String channelCode) throws IOException {
        String s = monitorService.fileCode(channelCode);
        Result success = Result.success(s);
        return success;
    }
}
