package com.hisense.monitormanage.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.hisense.monitormanage.entity.PassengerTest;
import com.hisense.monitormanage.entity.Result;
import com.hisense.monitormanage.mapper.PassengerTestMapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@Api(tags = "人流测试点")
@RequestMapping("api/project/passenger")
public class PassengerTestController {

    @Autowired
    private PassengerTestMapper passengerTestMapper;

    /**
     * 查询全部人流测试点
     *
     * @return
     */
    @GetMapping("selectPassengerTest")
    @ApiOperation("查询全部人流测试点")
    public Result selectPassengerTest() {
        QueryWrapper<PassengerTest> queryWrapper = new QueryWrapper<>();
        List<PassengerTest> passengerTests = passengerTestMapper.selectList(queryWrapper);
        Result success = Result.success(passengerTests);
        return success;
    }
}
