package com.hisense.monitormanage.controller;

import com.hisense.monitormanage.dto.PeopleRecognizeDto;
import com.hisense.monitormanage.entity.Result;
import com.hisense.monitormanage.mapper.PeopleRecognizeMapper;
import com.hisense.monitormanage.service.MonitorService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("api/project/people")
@Api(tags = "人流识别算法")
public class PeopleRecognizeController {

    @Autowired
    private MonitorService monitorService;

    @Autowired
    private PeopleRecognizeMapper peopleRecognizeMapper;

    /**
     * 查询全部安保区域人流
     *
     * @return
     */
    @GetMapping("selectPeopleRecognize")
    @ApiOperation("查询全部安保区域人流")
    public Result selectPeopleRecognize() {
        List<PeopleRecognizeDto> lists = peopleRecognizeMapper.selectPeopleRecognize();
        for (PeopleRecognizeDto list : lists) {
            String nodeName = list.getNodeName();
            list.setNewNodeName(nodeName);
            String[] splits = nodeName.split("->");
            String split = splits[1];
            list.setNodeName(split);
        }
        Result success = Result.success(lists);
        return success;
    }

    @GetMapping("recover")
    public Object recover() {
        monitorService.peopleRecognize();
        return "finish recover";
    }

}
