package com.hisense.monitormanage.controller;

import com.alibaba.fastjson.JSONObject;
import com.hisense.monitormanage.entity.CaseCityLaw;
import com.hisense.monitormanage.entity.Result;
import com.hisense.monitormanage.service.SJZTService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@Api(tags = "数交中台-城市执法案件")
@RestController
@RequestMapping("api/project")
public class SJZTController {
    @Autowired
    private SJZTService sjztService;

    //从接口获取案件数据
    @GetMapping("listSJZTDatas")
    @ApiOperation("获取案件数据,根据后台条件调用接口获取")
    public List<Map> listSJZTDatas() {
        return sjztService.listSJZTDatas();
    }

    //测试保存
    @GetMapping("batchSaveSJZT")
    @ApiOperation("测试保存，根据后台条件调用接口获取并保存到表，这个后台条件需要改动，也可能是做成自动任务调度")
    public void batchSaveSJZT() {
        sjztService.batchSave();
    }

    //从表中查询案件数据,需要根据要求增加条件
    @GetMapping("listSJZTByDt")
    @ApiOperation("获取案件数据，根据ajjlsj从表中获取")
    @ApiImplicitParam(name = "ajjlsj", value = "案件建立时间，2021-01-01", paramType = "query", required = true, dataType = "string")
    public List<CaseCityLaw> listSJZTByDt(
            @RequestParam(value = "ajjlsj") String ajjlsj
    ) {
        return sjztService.listSJZTByDt(ajjlsj);
    }

    @PostMapping("upStream")
    @ApiOperation("案件上报，调用接口上报,暂时未测试")
    public Result upStream(@ApiParam(value = "data,直接以json字符串的形式传递", required = true) @RequestBody String data) {
        System.out.println("案件上报，调用接口上报");
        return sjztService.upStream(JSONObject.parseObject(data));
    }
}
