package com.hisense.monitormanage.controller;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.hisense.monitormanage.entity.Camera;
import com.hisense.monitormanage.entity.Result;
import com.hisense.monitormanage.mapper.CameraMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.HashMap;

@RestController
@RequestMapping("api/static")
public class StaticController {

    @Autowired
    private CameraMapper cameraMapper;

    @RequestMapping("all")
    public Object all() {
        HashMap<Object, Object> map = new HashMap<>();
        //
        Integer cameraCount = cameraMapper.selectCount(null);
        map.put("cameraCount", cameraCount);
        LambdaQueryWrapper<Camera> queryWrapper = new QueryWrapper<Camera>().lambda()
                .gt(Camera::getCaptureTime, DateUtil.beginOfDay(new Date()));
        Integer todayCount = cameraMapper.selectCount(queryWrapper);
        map.put("todayCount", todayCount);

        return Result.success(map);
    }


}
