package com.hisense.monitormanage.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName BuildingRecords.java
 * @Description 工地实时信息类
 * @createTime 2022年05月17日 15:28:00
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName("t_building_records")
@ApiModel("工地实时数据")
public class BuildingRecords {

    @TableId
    @ApiModelProperty("id")
    private Integer id;

    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("项目建筑批准编号")
    private String buildLicense;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty("数据上传时间")
    private LocalDateTime pushTime;

    @ApiModelProperty("appid")
    private String appid;

    @ApiModelProperty("pm10值")
    private double pm10;

    @ApiModelProperty("噪音值")
    private double noice;

}
