package com.hisense.monitormanage.entity;


import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class Result<T> {

    private int code;

    private String message;

    private T data;

    private int count;

    static public Result success() {
        return Result.builder()
                .code(1)
                .message("success")
                .build();
    }

    static public Result success(Object obj) {
        return Result.builder()
                .code(1)
                .message("success")
                .data(obj)
                .build();
    }

    static public Result error(String errMsg) {
        return Result.builder()
                .code(0)
                .message(errMsg)
                .build();
    }

}
