package com.hisense.monitormanage.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName RoadData.java
 * @Description 道路统计数据
 * @createTime 2022年05月11日 11:10:00
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName("t_road_data")
public class RoadData {

    @TableId
    private Integer id;

    private String regionName;

    private String streetName;

    private String roadName;

    private String start;

    private String end;

    private double lng;

    private double lat;

    private double pm10;

    private double pm25;

    private Integer descPm10Rank;

    private Integer ascPm10Rank;

    private Integer descPm25Rank;

    private Integer ascPm25Rank;

    private String points;

    @JsonFormat(pattern = "yyyy-MM-dd mm:HH:ss", timezone = "GMT+8")
    private String dt;

}
