package com.hisense.monitormanage.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName Sanitation.java
 * @Description 环卫车基础信息类
 * @createTime 2022年05月19日 11:24:00
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName("t_sanitation_info")
@ApiModel("环卫车辆基础数据")
public class Sanitation {

    @TableId
    @ApiModelProperty("id")
    private Integer id;

    @ApiModelProperty("车牌号")
    private String cph;

    @ApiModelProperty("驾驶员")
    private String jsy;

    @JsonFormat(pattern = "yyyy-MM-dd mm:HH:ss", timezone = "GMT+8")
    @ApiModelProperty("购买日期")
    private LocalDateTime gmri;

    @ApiModelProperty("车辆类型")
    private String cllx;

    @ApiModelProperty("所属区域编号")
    private String ssqybh;

    @ApiModelProperty("所属环卫公司编号")
    private String sshwgsbh;

    @ApiModelProperty("备注")
    private String bz;

    @ApiModelProperty("是否考核")
    private Integer sfkh;

    @ApiModelProperty("车辆编号")
    private String clbh;

    @ApiModelProperty("吨数")
    private String ds;

    @ApiModelProperty("是否加装GPS并连入市监管平台")
    private String sfjzgpsblrsjgpt;

    @ApiModelProperty("简介")
    private String jj;

    @ApiModelProperty("车辆型号")
    private String clxh;

    @ApiModelProperty("车辆大类")
    private String cldl;

    @ApiModelProperty("是否机扫")
    private Integer sfjs;

    @ApiModelProperty("是否洒水")
    private Integer sfss;

    @ApiModelProperty("是否冲洗")
    private Integer sfcx;

}
