package com.hisense.monitormanage.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName SanitationTask.java
 * @Description 环卫车作业数据
 * @createTime 2022年05月20日 13:33:00
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName("t_sanitation_task")
@ApiModel("环卫车辆作业数据")
public class SanitationTask {

    @TableId
    @ApiModelProperty("id")
    private Integer id;

    @ApiModelProperty("道路名称")
    private String dlmc;

    @ApiModelProperty("开始道路")
    private String ksdl;

    @ApiModelProperty("终止道路")
    private String zzdl;

    @ApiModelProperty("所属区市")
    private String ssqs;

    @ApiModelProperty("车牌号")
    private String cph;

    @ApiModelProperty("作业完成率")
    private double zywcl;

    @JsonFormat(pattern = "yyyy-MM-dd mm:HH:ss", timezone = "GMT+8")
    @ApiModelProperty("作业日期")
    private LocalDateTime zyrq;

    @ApiModelProperty("作业类型")
    private String zylx;

    @ApiModelProperty("作业时间")
    private String zysj;

    @ApiModelProperty("作业趟数")
    private double zyts;

    @ApiModelProperty("作业频次")
    private double zypc;

    @ApiModelProperty("作业长度")
    private double zyzd;

    @ApiModelProperty("作业宽度")
    private double zykd;

    @ApiModelProperty("作业面积")
    private double zymj;

    @ApiModelProperty("未作业点数")
    private double wzyds;

    @ApiModelProperty("作业超速点数")
    private double zycsds;

    @ApiModelProperty("作业GPS点数")
    private double zygpsds;

    @JsonFormat(pattern = "yyyy-MM-dd mm:HH:ss", timezone = "GMT+8")
    @ApiModelProperty("上传时间")
    private LocalDateTime updatetime;

}
