package com.hisense.monitormanage.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hisense.monitormanage.dto.CameraChannelDto;
import com.hisense.monitormanage.dto.CameraChannelDto1;
import com.hisense.monitormanage.dto.CameraChannelNLDto;
import com.hisense.monitormanage.dto.ChannelLabelDto;
import com.hisense.monitormanage.entity.CameraChannel;
import com.hisense.monitormanage.entity.Label;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface CameraChannelMapper extends BaseMapper<CameraChannel> {

    void updateCameraStatus(List<String> list);

    List<CameraChannelDto> selectAll();

    @Select("select cc.*,cp.pic_url from t_camera_channel cc LEFT JOIN t_channel_picture cp ON cc.channel_code=cp.channel_code where cc.channel_code = #{channelCode}")
    List<CameraChannelDto1> selectByChannelCode(@Param("channelCode") String channelCode);

    @Select("select * from t_camera_channel where parent_id = #{parentId} and check_status in (${checkStatus}) ")
    List<CameraChannel> selectByParentId(@Param("parentId") String parentId,
                                         @Param("checkStatus") String checkStatus);

    @Select("select c.* from t_camera_channel c where channel_code in " +
            "(select b.channel_code from t_channel_mtm_label b  where b.label_code = #{labelCode})  ")
    List<ChannelLabelDto> selectLabel(@Param("labelCode") String labelCode);

    @Select("select * from t_label")
    List<Label> selectAllLabel();

    @Select("select * from t_label where city = 1 ")
    List<Label> selectByLabelCity();

    @Select("select * from t_label where label_name like concat('%',#{labelName},'%')")
    List<Label> selectByLabelName(String labelName);

    @Select("select * from t_camera_channel where channel_name like concat('%',#{channelName},'%')")
    List<CameraChannel> selectByChannelName(String channelName);

    @Select("select * from (select a.label_code,a.label_name,c.channel_code,c.channel_name from t_channel_mtm_label b JOIN t_label a JOIN t_camera_channel c " +
            "ON a.label_code = b.label_code AND b.channel_code = c.channel_code where c.`status`!= 0) m where m.label_code in (${labelCode}) ")
    List<ChannelLabelDto> selectLabelAndChannel(@Param("labelCode") String labelCode);

    @Select("select cc.* from t_camera_channel cc " +
            "where (gps_x between #{gpsX} and #{gpsX1}) and (gps_y between #{gpsY} and #{gpsY1} )")
    List<CameraChannel> selectAllByGps(@Param("gpsX") Double gpsX,
                                       @Param("gpsX1") Double gpsX1,
                                       @Param("gpsY") Double gpsY,
                                       @Param("gpsY1") Double gpsY1);

    List<CameraChannelNLDto> selectNLAll(@Param("page") Integer page, @Param("pageSize") Integer pageSize);

    @Select("SELECT * FROM t_camera_channel WHERE channel_code < '009_37021544001321925022' AND channel_code > '009_37021502001321352341' ORDER BY channel_code DESC")
    List<CameraChannel> selectCameraChannel();

}
