package com.hisense.monitormanage.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hisense.monitormanage.dto.EventDto;
import com.hisense.monitormanage.entity.Event;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface EventMapper extends BaseMapper<Event> {

    List<EventDto> selectEvent(@Param("page") Integer page, @Param("pageSize") Integer pageSize);

    @Select("select count(*) from t_event where track_event = 'START'")
    Integer selectCountEvent();

    @Select("SELECT * FROM t_event where TO_DAYS(capture_time) = TO_DAYS(NOW()) AND track_event = 'START'")
    List<EventDto> selectByTime();

    List<EventDto> selectByName(@Param("eventNewName") String eventNewName, @Param("page") Integer page, @Param("pageSize") Integer pageSize);

    @Select("select count(*) from t_event where  track_event = 'START' and event_cn_name in (${eventNewName})")
    Integer selectCountByName(@Param("eventNewName") String eventNewName);

    @Select("SELECT * FROM t_event where TO_DAYS(capture_time) = TO_DAYS(NOW()) AND event_cn_name in (${eventNewName}) AND track_event = 'START'")
    List<EventDto> selectByTimeAndName(@Param("eventNewName") String eventNewName);
}
