package com.hisense.monitormanage.mapper;


import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hisense.monitormanage.dto.PassengerFlowDto;
import com.hisense.monitormanage.entity.PassengerFlow;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface PassengerFlowMapper extends BaseMapper<PassengerFlow> {

    void batchSave(List<Map> list);

    PassengerFlow getByMaxId();

    List<PassengerFlow> selectByTime(String timeId);

    @Select("select distinct pf.hour_id,pf.time_id,pf.longitude,pf.latitude,pf.all_nums,pf.local_nums,pf.nonlocal_nums from t_passenger_flow pf " +
            "where (longitude between #{longitude} and #{longitude1}) and (latitude between #{latitude} and #{latitude1} ) and time_id = #{timeId}")
    List<PassengerFlowDto> selectPassenger(@Param("longitude") Double longitude,
                                           @Param("longitude1") Double longitude1,
                                           @Param("latitude") Double latitude,
                                           @Param("latitude1") Double latitude1,
                                           @Param("timeId") String timeId);
}
