package com.hisense.monitormanage.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hisense.monitormanage.dto.RoadDataDtos;
import com.hisense.monitormanage.entity.PassengerFlow;
import com.hisense.monitormanage.entity.RoadData;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName RoadDataMapper.java
 * @Description TODO
 * @createTime 2022年05月11日 11:10:00
 */
@Repository
public interface RoadDataMapper extends BaseMapper<RoadData> {

    void batchSave(List<Map> list);

    List<RoadData> selectRoadData(@Param("page") Integer page, @Param("pageSize") Integer pageSize);

    @Select("select count(*) from t_road_data where pm10 > 150")
    Integer selectCountRoadData();

    @Select("select count(*) from t_road_data where pm10 > 150 and DATE_SUB(CURDATE(), INTERVAL 7 DAY) < DATE(dt)")
    Integer selectCountWeekRoadData();

    @Select("select count(*) from t_road_data where pm10 > 150 and DATE_SUB(CURDATE(), INTERVAL 30 DAY) < DATE(dt)")
    Integer selectCountMonthRoadData();

    RoadData getByMaxId();

    @Select("select * from t_road_data where dt between #{begin} and #{over} and pm10 > 150 order by dt asc ")
    List<RoadDataDtos> listRoadDataByTimeRegion(@Param("begin") String begin, @Param("over") String over);
}
