package com.hisense.monitormanage.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hisense.monitormanage.dto.ScenicCameraDto;
import com.hisense.monitormanage.entity.Camera;
import com.hisense.monitormanage.entity.Scenic;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ScenicMapper extends BaseMapper<Scenic> {

    //带去重
    @Select("select cam.* from t_camera cam, (SELECT DISTINCT camera_id FROM t_scenic_mtm_camera) sc WHERE cam.`code` = sc.camera_id")
    List<Camera> selectCamerasInScenic();

    //不去重，按景区纬度提取摄像头
    @Select("select ts.*,cam.*,cs.person_num from t_scenic_mtm_camera sc  JOIN t_camera cam ON cam.`code` = sc.camera_id JOIN t_scenic ts ON ts.id = sc.scenic_id LEFT JOIN t_camera_scenic cs ON cam.`code` = cs.camera_id")
    List<ScenicCameraDto> selectScenicCameras();
}
