package com.hisense.monitormanage.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hisense.monitormanage.dto.WaterCameraDto;
import com.hisense.monitormanage.dto.WaterPointDto;
import com.hisense.monitormanage.dto.WaterPointDtos;
import com.hisense.monitormanage.entity.CameraChannel;
import com.hisense.monitormanage.entity.WaterPoint;
import com.hisense.monitormanage.entity.WaterPointPolice;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface WaterPointMapper extends BaseMapper<WaterPoint> {

    List<WaterPointDto> selectWaterPoint();

    @Select("select * from water_point wp LEFT JOIN water_point_report wpr ON wp.water_point_id = wpr.water_point_id where audit_flag = '2' and disp_flag in (0,1) and report_origin = #{reportOrigin}")
    List<WaterPointDto> selectReportOrigin(String reportOrigin);

    @Select("SELECT * FROM w_camera w RIGHT JOIN water_camera wc ON w.water_id = wc.water_id where wc.water_point_name = #{waterPointName}")
    List<WaterCameraDto> selectCameraByName(String waterPointName);

    @Select("select wc.ssqy,COUNT(*) as count from water_point wp JOIN water_camera wc ON wp.water_point_name = wc.water_point_name  WHERE wp.audit_flag = '2' and wp.disp_flag in (0,1) GROUP BY wc.ssqy")
    List<WaterPointDtos> selectCountWater();


    List<WaterPointDtos> selectCountWaters();

    @Select("select wpr.point_level,COUNT(*) as count from water_point wp LEFT JOIN water_point_report wpr ON wp.water_point_id = wpr.water_point_id WHERE wp.audit_flag = '2' and wp.disp_flag in (0,1) GROUP BY wpr.point_level")
    List<WaterPointDtos> selectCountLevel();

    @Select("select * from water_point where (longitude between #{longitude1} and #{longitude2}) and (latitude between #{latitude1} and #{latitude2} ) and audit_flag = '2' and disp_flag in (0,1)")
    List<WaterPoint> selectByLongAndLiti(@Param("longitude1") Double longitude1,
                                         @Param("longitude2") Double longitude2,
                                         @Param("latitude1") Double latitude1,
                                         @Param("latitude2") Double latitude2);

    @Select("select * from water_point_police")
    List<WaterPointPolice> selectWaterPoliceList();


}
