package com.hisense.monitormanage.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.hisense.monitormanage.entity.BuildingSite;
import com.hisense.monitormanage.mapper.BuildingSiteMapper;
import com.hisense.monitormanage.utils.LongLatUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName BuildingSitrService.java
 * @Description TODO
 * @createTime 2022年05月12日 13:58:00
 */
@Service
@Slf4j
public class BuildingSiteService {
    @Autowired
    private BuildingSiteMapper buildingSiteMapper;

    public List<BuildingSite> listBuildingSiteByPoints(double longitude, double latitude, Integer radius) {
        List<BuildingSite> list = new ArrayList<>();
        try {
            double[] points = LongLatUtil.getAround(longitude, latitude, radius);
            QueryWrapper<BuildingSite> wrapper = new QueryWrapper();
            wrapper.between("jd", points[0], points[2]).between("wd", points[1], points[3]);
            list = buildingSiteMapper.selectList(wrapper);
        } catch (Exception e) {
            log.error("[listBuildingSiteByPoints] Exception:" + e.getMessage());
        }
        return list;
    }
}
