package com.hisense.monitormanage.service;

import com.alibaba.fastjson.JSONObject;
import com.hisense.monitormanage.dto.CameraChannelDto;
import com.hisense.monitormanage.mapper.CameraChannelMapper;
import com.hisense.monitormanage.utils.EhcacheUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.ehcache.EhCacheCacheManager;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.List;

/**
 * @author admin
 * @version 1.0.0
 * @ClassName CameraChannelService.java
 * @Description TODO
 * @createTime 2022年05月12日 09:19:00
 */
@Service
public class CameraChannelService {
    @Autowired
    private CameraChannelMapper cameraChannelMapper;

    @Autowired
    private EhCacheCacheManager ehCacheCacheManager;

    //查询所有摄像头
    //@Cacheable(value = "fillIn")
    public String selectAll() {
        String list = (String) EhcacheUtil.getInstance().get("fillIn", "allCameraList");
        if (StringUtils.isEmpty(list)) {
            List<CameraChannelDto> cameraChannelDtos = cameraChannelMapper.selectAll();
            list = JSONObject.toJSONString(cameraChannelDtos);
            EhcacheUtil.getInstance().put("fillIn", "allCameraList", list);
        }
        return list;
    }

}
