package com.hisense.monitormanage.service;

import cn.hutool.crypto.SecureUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.hisense.monitormanage.entity.Event;
import com.hisense.monitormanage.mapper.EventMapper;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Log4j2
public class EventService {

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private EventMapper eventMapper;

    //1.登录
    //2.获取token
    public String shangtangToken() {
        String url = "http://10.132.191.54:10270/whale-open-api/tenant/token";

        Map<String, Object> map = new HashMap<>();
        map.put("accessKey", "a1ddCV7z7Jhv0SBGx5O3hblO");
        map.put("secretKey", "glIixzORLgoFJz0VdF1aXICR");
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.postForEntity(url, map, JSONObject.class);
            JSONObject body = responseEntity.getBody();
            JSONObject data = body.getJSONObject("data");
            String token = data.getString("token");
            log.info("get token:{}", body.toJSONString());
            return token;
        } catch (Exception e) {
            log.info("[shangtangToken] exception:{}", e.getMessage());
            return null;
        }
    }

    //订阅任务下发接口
    public JSONObject subscribe() {
        String token = this.shangtangToken();
        String url = "http://10.132.191.54:10270/whale-open-api/subscribe";

        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);

        headers.add("token", token);
        headers.add("tid", "default");

        Map<String, Object> map = new HashMap<>();
        map.put("callBackUrl", "http://15.2.23.205:7009/STapi/project/receive");
//        map.put("certPubKey","");
        map.put("subscribeType", 3);
//        map.put("taskId","serial");

        ResponseEntity<JSONObject> responseEntity;
        HttpEntity<String> entity = new HttpEntity<>(JSONObject.toJSONString(map), headers);
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.POST, entity, JSONObject.class);
            JSONObject body = responseEntity.getBody();
            return body;
        } catch (Exception e) {
            log.info("[subscribe] exception:{}", e.getMessage());
            return null;
        }

    }

    //事件模板分页查询接口
    public JSONObject template() {
        String token = this.shangtangToken();
        String url = "http://10.132.191.54:10270/whale-open-api/scenario/event/template?pageNum=1&pageSize=1000";

        HttpHeaders headers = new HttpHeaders();
        headers.add("token", token);
        headers.add("tid", "default");

        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, new HttpEntity<>(headers), JSONObject.class);
            JSONObject jsonObject = responseEntity.getBody();
            return jsonObject;
        } catch (Exception e) {
            log.info("[template] exception:{}", e.getMessage());
            return null;
        }

    }

    public void screenshot() {
        String url = "http://218.58.65.132:2580/api/haixin";
        String image = "http://120.221.72.8:7002";
        QueryWrapper<Event> queryWrapper = new QueryWrapper<>();
        List<Event> events = eventMapper.selectList(queryWrapper);
        events.forEach(event -> {
            String key = "NcjzgcBOJaD79xQm";
            String sign = "cjname=" + event.getEventCnName() + "&datetime=" + event.getCaptureTime() + "&piclatitude=" + event.getLatitude() +
                    "&piclongitude=" + event.getLongitude() + "&resultpicurl1=" + event.getImageUrl() + "&vidorpic=" + 0 + "&key=" + key;
            Map<String, Object> map = new HashMap<>();
            map.put("cjname", event.getEventCnName());
            map.put("datetime", event.getCaptureTime());
            map.put("vidorpic", 0);
            String substring = event.getImageUrl().substring(26);
            map.put("resultpicurl1", image + substring);
            map.put("piclongitude", event.getLongitude());
            map.put("piclatitude", event.getLatitude());
            map.put("sign", SecureUtil.md5(sign));
            ResponseEntity<JSONObject> responseEntity;
            try {
                responseEntity = restTemplate.postForEntity(url, map, JSONObject.class);
                JSONObject body = responseEntity.getBody();
                System.out.println(body);
            } catch (Exception e) {
                log.info("[screenshot] exception:{}", e.getMessage());
            }
        });

    }

}
