package com.hisense.monitormanage.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class QidiService {

    @Autowired
    private RestTemplate restTemplate;

    //启迪数据中台相关
    //1.登录
    public String qidiToken() {
        String url = "http://120.221.95.13:9090/apin/authorization/oauth/token";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Basic dGVzdF9jbGllbnQ6ZTk4OWQ0NmZkYmMxYzM3NmMxOWE0M2FhZjg1MjI3YTQ=");
        headers.add("Content-Type", "application/x-www-form-urlencoded");

        MultiValueMap map = new LinkedMultiValueMap();
        map.add("username", "dlwr");
        map.add("password", "aa20f6046b76fa7bb7566d8fd3445d4d");//Dlwr@123456,需要MD5加密
        map.add("scope", "read");
        map.add("grant_type", "password");
        map.add("vc", "NO");

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(map, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.POST, request, JSONObject.class);
            JSONObject jsonObject = responseEntity.getBody();
            if (jsonObject.getBooleanValue("success") == true) {
                JSONObject resultJson = jsonObject.getJSONObject("result");
                return resultJson.getString("accessToken");
            } else {
                return null;
            }
        } catch (Exception e) {
            log.info("[qidiToken] exception:{}", e.getMessage());
            return null;
        }
    }

    //渣土车轨迹数据,最新的
    public List<Map> resCatalogApplyZTYS() {
        String token = this.qidiToken();
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_ZTYS_307013600000000022_2";

        HttpEntity<Map> httpEntity = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, httpEntity, JSONObject.class);

            JSONObject jsonObject = responseEntity.getBody();
            JSONArray jsonArray = jsonObject.getJSONArray("list");
            log.info("[resCatalogApplyZTYS] 返回数据的数量:{}", jsonArray.size());
            return JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);
        } catch (Exception e) {
            log.info("[resCatalogApplyZTYS] exception:{}", e.getMessage());
            return null;
        }
    }

    //环卫车轨迹数据
    public List<Map> resCatalogApplyHJWS() {
        String token = this.qidiToken();
        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_HJWS_307013400000000442_1";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, request, JSONObject.class);
            JSONObject jsonObject = responseEntity.getBody();
            JSONArray jsonArray = jsonObject.getJSONArray("list");
            return JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);
        } catch (Exception e) {
            log.info("[resCatalogApplyHJWS] exception:{}", e.getMessage());
            return null;
        }
    }

    //工地信息
    public List<Map> resCatalogApplyGDYS() {
        String token = this.qidiToken();
        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_ZTYS_307013600000000025_1";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        Map<String, Object> map = new HashMap<>();
        JSONObject search = new JSONObject();
        search.put("opt", "LIKE");
        search.put("key", "updatetime");
        search.put("val", this.dateStr());
        map.put("json", search);

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, request, JSONObject.class);
            JSONObject jsonObject = responseEntity.getBody();
            JSONArray jsonArray = jsonObject.getJSONArray("list");
            return JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);
        } catch (Exception e) {
            log.info("[resCatalogApplyGDYS] exception:{}", e.getMessage());
            return null;
        }
    }

    //环卫车辆数据1，基础
    public List<Map> resCatalogApplyHJWSBase() {
        String token = this.qidiToken();
        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_HJWS_307013400000000365_1";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        Map<String, Object> map = new HashMap<>();
        JSONObject search = new JSONObject();
        search.put("opt", "EQ");
        search.put("key", "SSQY");
        search.put("val", "胶州市");
        map.put("json", search);

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, request, JSONObject.class);
            JSONObject jsonObject = responseEntity.getBody();
            JSONArray jsonArray = jsonObject.getJSONArray("list");
            return JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);
        } catch (Exception e) {
            log.info("[resCatalogApplyHJWSBase] exception:{}", e.getMessage());
            return null;
        }
    }

    //环卫车辆数据2,作业,5月20号已经把能查到的都保存到表中了(忘了保存updatetime)
    public List<Map> resCatalogApplyHJWSZY() {
        String token = this.qidiToken();
        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_HJWS_307013400000000363_1";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        Map<String, Object> map = new HashMap<>();
        JSONObject search = new JSONObject();
        map.put("json", search);

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, request, JSONObject.class, map);
            JSONObject jsonObject = responseEntity.getBody();
            JSONArray jsonArray = jsonObject.getJSONArray("list");
            return JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);
        } catch (Exception e) {
            log.info("[resCatalogApplyHJWSBase] exception:{}", e.getMessage());
            return null;
        }
    }

    public List<Map> resCatalogApplyHJWSZY(String updatetime) throws Exception {
        String token = this.qidiToken();
        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_HJWS_307013400000000363_1?search=[{json}]";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        List<Map> maps = new ArrayList<>();
        Map<String, Object> map = new HashMap<>();
        JSONObject search = new JSONObject();
        search.put("opt", "GT");
        search.put("key", "updatetime");
        search.put("val", updatetime);
        map.put("json", search);

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        responseEntity = restTemplate.exchange(url, HttpMethod.GET, request, JSONObject.class, map);
        JSONObject jsonObject = responseEntity.getBody();
        JSONArray jsonArray = jsonObject.getJSONArray("list");
        maps = JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);

        return maps;
    }

    //环卫道路明细数据
    public List<Map> resCatalogApplyHJWSRoad() {
        String token = this.qidiToken();
        String url = "http://120.221.95.13:9090/catalog/resCatalogApply/getData/UC_QUERY_HJWS_307013400000000370_2";
        HttpHeaders headers = new HttpHeaders();
        headers.add("Authorization", "Bearer " + token);

        Map<String, Object> map = new HashMap<>();

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(null, headers);
        ResponseEntity<JSONObject> responseEntity;
        try {
            responseEntity = restTemplate.exchange(url, HttpMethod.GET, request, JSONObject.class);
            JSONObject jsonObject = responseEntity.getBody();
            JSONArray jsonArray = jsonObject.getJSONArray("list");
            return JSONObject.parseArray(JSONObject.toJSONString(jsonArray), Map.class);
        } catch (Exception e) {
            log.info("[resCatalogApplyHJWSRoad] exception:{}", e.getMessage());
            return new ArrayList<>();
        }
    }

    //获取当前日期的时间串，2022-05-08 00:00:00
    private String dateTimeStr() {
        LocalDate localDate = LocalDate.now();
        LocalDate yestDay = localDate.minusDays(1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        LocalDateTime dateTime = LocalDateTime.of(yestDay.getYear(), yestDay.getMonth(), yestDay.getDayOfMonth(), 0, 0, 0);
        return dateTime.format(formatter);
    }

    //获取当前日期的时间串，2022-05-08
    private String dateStr() {
        LocalDate localDate = LocalDate.now();
        LocalDate yestDay = localDate.minusDays(1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        return yestDay.format(formatter);
    }
}
